from Products.Five.browser import BrowserView
from Products.CMFCore.utils import getToolByName

class ReindexDiscussions(BrowserView):
    def __call__(self):
        if self.request['REQUEST_METHOD'] == 'GET':
            return """
                <html>
                    <body>
                        <form method='post' action='"""+self.context.absolute_url()+"""/@@reindex_discussions'>
                            <input type='submit' value='Reindex all discussions'/>
                        </form>
                    <body>
                </html>"""
        else:
            cat = getToolByName(self.context,'portal_catalog')
            brains = cat({
                'object_provides': [
                    'ubify.coretypes.interfaces.IDiscussion',
                ]
            })

            for brain in brains:
                obj = brain.getObject()
                obj.reindexObject()
                return "Done"