from Products.CMFCore.utils import getToolByName
from Products.CMFNotification.NotificationTool import ID as TOOL_ID

def onDiscussionAddedEvent(obj,event):
    ntool = getToolByName(obj, TOOL_ID)
    ntool.subscribeTo(obj)

def onCommentAddedEvent(obj,event):
    
    rootobj = obj.aq_parent.aq_parent
    shouldSubscribe = True
    if obj.Creator() == rootobj.Creator():
        shouldSubscribe = False
        
    if shouldSubscribe:
        container = obj.aq_parent
        commentsCount = 0
        for comment in container.objectValues():
            if obj.Creator() == comment.Creator():
                commentsCount += 1
        if commentsCount > 1:
            shouldSubscribe = False
                           
    if shouldSubscribe:
        ntool = getToolByName(rootobj, TOOL_ID)
        ntool.subscribeTo(rootobj)
